(function(app) {
  app.LanguagesComponent = ng.core
    .Component({
      selector: 'languages-list',
      templateUrl: 'languages.html',
      providers: [ng.http.HTTP_PROVIDERS, app.LanguagesService, app.LanguagesSortPipe]
    })
    .Class({
      constructor: [
      app.LanguagesService, app.LanguagesSortPipe,
      function(_languagesService, _languagesSortPipe) {
        this.languages = [];
        this.message = '';
        this.service = _languagesService;
        this.pipe = _languagesSortPipe;
        this.newLanguage = {name: '', author: ''};
      }],
      getLanguages: function() {
        this.service.get()
            .subscribe(this.updateLanguages.bind(this),
                       this.updateError.bind(this));
      },
      updateLanguages: function(languages) {
        this.languages = this.pipe.transform(languages);
      },
      updateError: function(message) {
        this.message = message;
      },                            
      addLanguage: function() {
        this.service.add(this.newLanguage)
                    .subscribe(this.updateMessage.bind(this),
                               this.updateError.bind(this));
      },
      updateMessage: function(message) {
        this.message = message;      
        this.getLanguages();
      },                    
      deleteLanguage: function(languageId) {
        this.service.delete(languageId)
            .subscribe(this.updateMessage.bind(this),
                       this.updateError.bind(this));
        
      },
      ngOnInit: function() {
        this.getLanguages();
      }
    });
})(window.app || (window.app = {}));