describe('languages sort pipe test', function() {
  var pipe;
  
  beforeEach(function() {
    pipe = new app.LanguagesSortPipe();
  });
  
  it('should sort languages by name', function() {
    var languages = [
      {id: 1, name: 'b', author: 'a1'},
      {id: 2, name: 'a', author: 'a3'},
      {id: 3, name: 'c', author: 'a3'},
    ];   
   
   var sorted = pipe.transform(languages);
   
   expect(sorted[0]).to.be.eql(languages[1]);
   expect(sorted[1]).to.be.eql(languages[0]);
   expect(sorted[2]).to.be.eql(languages[2]);
  });             
  
  //... more tests on transform ...
  
  it('should have a name', function() {
    var annotations = 
      Reflect.getMetadata("annotations", app.LanguagesSortPipe)[0];
      
    expect(annotations.name).to.be.eql('sort');
  });
});